function Hess = hessVec(prob,x,h)
%HESSVEC   Apply the hessian
%
%  Apply the hessian at x on a tangent vector h, H[h].



% P_t ( P_Omega( h ) )
h_omega = partXY([x.U*h.M+h.Up x.U]',[x.V h.Vp]', prob.Omega_i, prob.Omega_j, prob.m)'; % BARt
%h_omega = XonOmega([x.U*h.M+h.Up x.U], [x.V h.Vp], prob.Omega);
%h_omega = proj_omega_sub([x.U*h.M+h.Up x.U],[x.V h.Vp], prob.Omega_i, prob.Omega_j)'; % trying for comparisons



updateSparse(prob.temp_omega, h_omega);% mex file
 

Up1 = prob.temp_omega *x.V; % I also use this
Vp1 = prob.temp_omega'*x.U; % I also use this
Hess.M = x.U'*Up1;

% P_U * P_Omega( err ) * ... * P_Vp
% reg inverse
%i_s = 1./x.sigma;

inv_sigma = diag(1./x.sigma);
d = x.on_omega - prob.data;

updateSparse(prob.temp_omega, d); % mex file


Vp2 = prob.temp_omega'*(h.Up*inv_sigma); % I also use this
Up2 = prob.temp_omega *(h.Vp*inv_sigma); % I also use this

Hess.Up = Up1 + Up2;
Hess.Up = Hess.Up - x.U*(x.U'*Hess.Up);
Hess.Vp = Vp1 + Vp2;
Hess.Vp = Hess.Vp - x.V*(x.V'*Hess.Vp);