function Hess = hessVec_simp(prob,x,h)
%HESSVEC   Apply the hessian
%
%  Apply the hessian at x on a tangent vector h, H[h].


% P_t ( P_Omega( h ) )
h_omega = XonOmega([x.U*h.M+h.Up x.U], [x.V h.Vp], prob.Omega);
updateSparse(prob.temp_omega, h_omega);
T = prob.temp_omega*x.V;
Hess.M = x.U'*T;
Up1 = T;
Vp1 = prob.temp_omega'*x.U;

% P_U * P_Omega( err ) * ... * P_Vp
% reg inverse
%i_s = 1./x.sigma;

Hess.Up = Up1;
Hess.Up = Hess.Up - x.U*(x.U'*Hess.Up);
Hess.Vp = Vp1;
Hess.Vp = Hess.Vp - x.V*(x.V'*Hess.Vp);