function [prob,options,x0] = init_LRGeomCG(M, r)
% Init the solver LRGeomCG with a random init guess.

d1 = M.size1; d2 = M.size2;

%% Init initial guess
G = randn(d1, r);
H = randn(d2, r);
[Q1, R1] = qr(G, 0);
[Q2, R2] = qr(H, 0);
[qL S qR] = svd(R1*R2');
U = Q1*qL;
B = S;
V = Q2*qR;

x0.U = U;
x0.sigma = diag(B);
x0.V = V;


%% Init prob
prob.r = r;
prob.k = r;
prob.n1 = M.size1; 
prob.n2 = M.size2;
prob.m = length(M.ind_Omega);

prob.Omega_i = M.row';
prob.Omega_j = M.col';
prob.data = M.values_Omega'; % we need a column vector!
prob.Omega = M.ind_Omega';

prob.temp_omega = sparse(prob.Omega_i, prob.Omega_j, prob.data*1,prob.n1,prob.n2,prob.m);
prob.mu = 0;


%% Init options
options = default_opts();


