function x = make_start_x(prob)
% Compute a truncated SVD for starting guess.

M_omega = sparse(prob.Omega_i, prob.Omega_j, ...
    prob.data,prob.n1,prob.n2,prob.m);
[U,S,V] = svds(M_omega, prob.r);
x.V = V;
x.sigma = diag(S);
x.U = U;

r = prob.r;
G = randn(prob.n1, r);
H = randn(prob.n2, r);
[Q1, R1] = qr(G, 0);
[Q2, R2] = qr(H, 0);
[qL S qR] = svd(R1*R2');
x.U = Q1*qL;
x.sigma = diag(S);
x.V = Q2*qR;

x = prepx(prob, x);


