function[eta_new] = vector_transport_ubv(model, eta, model_new)
% Transport vector eta at model to model_new

ip_old = inner_product_ubv(model, eta, eta);

eta.U = proj_tangent_space_stiefel(eta.U, model_new.U);
eta.V = proj_tangent_space_stiefel(eta.V, model_new.V);

[Z_U, Z_B, Z_V] = proj_horizontal_space_ubv(eta, model_new);
eta_new.U = Z_U;
eta_new.V = Z_V;
eta_new.B = Z_B;

ip_new = inner_product_ubv(model_new, eta_new, eta_new);

scaling = (ip_old / ip_new);

eta_new.U = scaling * eta_new.U;
eta_new.V = scaling * eta_new.V;
eta_new.B = scaling * eta_new.B;
