function [grad x] = grad_ubv(prob, x)

  d = (x.on_omega - prob.data);
  updateSparse(prob.temp_omega_2, d);
  prob.temp_omega_2 = prob.temp_omega_2;
  S = prob.temp_omega_2;
  
  SV = S*x.V;
  SU = S'*x.U;
  
  grad.U = SV*x.B;
  grad.U = proj_tangent_space_stiefel(grad.U, x.U); % projection on the tangent space

  grad.V = SU*x.B;
  grad.V = proj_tangent_space_stiefel(grad.V, x.V); % projection on the tangent space
  
  symmUSV = symm(x.U'*SV);
  grad.B = x.B*symmUSV*x.B;
  
  x.cache.S = S;
  x.cache.SU = SU;
  x.cache.SV = SV;
  x.cache.USV = x.U'*SV;
          
end