function h = removeVxM_ubv(x, h)
% Remove the vertical component of tangent vector h at x

 
% h.U = proj_tangent_space_stiefel(h.U,x.U); % numerical
% h.V = proj_tangent_space_stiefel(h.V,x.V); % numerical

 
  SS = x.B*x.B;
  AS = x.B*(skew(x.U'*h.U) + skew(x.V'*h.V) - 2*skew(x.B\h.B))*x.B;
  omega = sylvester(SS,AS);
  
  h.U = h.U - x.U*omega - x.U*symm(x.U'*h.U);
  h.B = h.B - (x.B*omega - omega*x.B) ;
  h.V = h.V - x.V*omega - x.V*symm(x.V'*h.V);
            


end