function[Z_G Z_H] = proj_horizontal_space_right_inv_gh(eta, model)
% [Z_G Z_H] = proj_horizontal_space_right_inv_gh(eta, model)
%
% Projecting a vector "eta" onto the horizontal space at the iterate "model".
% The output: Z_G: Projected left factor
%           : Z_H: Projected right factor
% 
% Author:
% Bamdev Mishra, <b.mishra@ulg.ac.be>, 2012

SS = (model.GtG)*(model.HtH);
AS = (model.GtG)*(model.H'*eta.H) - (eta.G'*model.G)*(model.HtH);

Omega = lyap(SS, SS, -AS);

Z_G = eta.G + model.G*Omega';
Z_H = eta.H - model.H*Omega;

return
