function model = quotient_gh_balancing_update(model)
% model = quotient_gh_balancing_update(model)
%
% Making the left and right factors numerically well-conditioned by making
% sure that their Frobenius norms are equal.
% 
% Author:
% Bamdev Mishra, <b.mishra@ulg.ac.be>, 2012

 scaling = sqrt(trace(model.GtG)/ trace(model.HtH));
 scaling = sqrt(scaling);
 model.G = model.G / scaling;
 model.H = model.H * scaling;
 
 model.GtG = model.GtG / (scaling^2);
 model.HtH = model.HtH * (scaling^2);
  
 

end 