function [Hess] = hess_right_inv_gh(prob, x, h)

%   s_star_single_proj = proj_omega_sub([h.G x.G], [x.H h.H], prob.Omega_i, prob.Omega_j);
  s_star_single_proj = partXY([h.G x.G]', [x.H h.H]', prob.Omega_i, prob.Omega_j, length(prob.Omega_i))';

  
  updateSparse(prob.temp_omega, s_star_single_proj);
  %prob.temp_omega = prob.temp_omega;
  S_star = prob.temp_omega;


  
  
  Hess.G = S_star*x.H*(x.GtG);
  Hess.H = S_star'*x.G*(x.HtH);
  
  
  if isempty(x.cache.S)
      d = (x.on_omega - prob.data);
      updateSparse(prob.temp_omega, d);
      prob.temp_omega = prob.temp_omega;
      S = prob.temp_omega;
  else
      S = x.cache.S;
  end

  
  if isempty(x.cache.SH)
      SH = S*x.H;
      SG = S'*x.G;
  else
      SH = x.cache.SH;
      SG = x.cache.SG;
  end
  
  ShH = S*h.H;
  ShG = S'*h.G;
  
   
  Hess.G = Hess.G + 2*SH*symm(h.G'*x.G) + ShH*(x.GtG);
  Hess.H = Hess.H + 2*SG*symm(h.H'*x.H) + ShG*(x.HtH);

   
  if isempty(x.cache.gradH)
      grad.G = SH*(x.GtG);
      grad.H = SG*(x.HtH);
  else
      grad.G = x.cache.gradG;
      grad.H = x.cache.gradH;
  end;
  
  if isempty(x.cache.HgradH)
      GgradG = x.G'*grad.G;
      HgradH = x.H'*grad.H;
  else
      GgradG = x.cache.GgradG;
      HgradH = x.cache.HgradH;
  end
  

  Hess.G = Hess.G - grad.G*((x.GtG)\symm(x.G'*h.G)) - h.G*(x.GtG \ symm(GgradG)) + x.G*((x.GtG)\symm(h.G'*grad.G));
  Hess.H = Hess.H - grad.H*((x.HtH)\symm(x.H'*h.H)) - h.H*(x.HtH \ symm(HgradH)) + x.H*((x.HtH)\symm(h.H'*grad.H));
  
  Hess = removeVxM_right_inv_gh(x, Hess); % projection on to horizontal space
  

end