function omega=nested_sylvester(sym_mat,asym_mat)
% omega=nested_sylvester(sym_mat,asym_mat)
% This function solves the system of nested Sylvester equations: 
%
%     X*sym_mat + sym_mat*X = asym_mat
%     Omega*sym_mat+sym_mat*Omega = X
% 
% [V, D] = eig(sym_mat);
% 
% p = size(sym_mat,2);
% O = zeros(p);
% O2 = V'*asym_mat*V;
% for i=1:p-1,
%     for j=i+1:p,
%         A = (D(i,i) + D(j,j))^2;
%         if A~=0, % FIXME shouldn't we add a slight tolerance here ?
%             O(i,j)=O2(i,j)/A;
%         else
%            O(i,j)=0;
%         end
%     end
% end
% O=O-O';
% omega=V*O*V';

X = lyap(sym_mat, -asym_mat);
omega = lyap(sym_mat, -X);