function[Z_U Z_Y] = proj_horizontal_space_uy(eta, model)
% [Z_G Z_H] = proj_horizontal_space_right_inv_gh(eta, model)
%
% Projecting a vector "eta" onto the horizontal space at the iterate "model".
% The output: Z_G: Projected left factor
%           : Z_H: Projected right factor
% 
% Author:
% Bamdev Mishra, <b.mishra@ulg.ac.be>, 2012
 
  SS = model.YtY;   
  
  AS1 = 2*model.YtY*skew(model.U'*eta.U)*model.YtY;
  AS2 = 2*skew(model.YtY*(model.Y'*eta.Y));      
  AS  = skew(AS1 + AS2);

  % TODO mex file
  Omega = nested_sylvester(SS,AS);
  
  Z_U = eta.U - model.U*Omega;
  Z_Y = eta.Y - model.Y*Omega;
  
  return
