function[eta_new] = vector_transport_uy(model, eta, model_new)
% [eta_new] = vector_transport_right_inv_gh(model, eta, model_new)
%
% Transport the vector "eta" at "model" to the new iterate, "model_new"
% The output is the trasported vector "eta_new" at the iterate "model_new".
%
% Author:
% Bamdev Mishra, <b.mishra@ulg.ac.be>, 2012
% (arXiv:1209.0430) 


ip_old = inner_product_uy(model, eta, eta);

eta.U = proj_tangent_space_stiefel(eta.U, model_new.U);
[Z_U Z_Y] = proj_horizontal_space_uy(eta, model_new);
eta_new.U = Z_U;
eta_new.Y = Z_Y;

ip_new = inner_product_uy(model_new, eta_new, eta_new);

scaling = (ip_old / ip_new);

eta_new.U = scaling * eta_new.U;
eta_new.Y = scaling * eta_new.Y;
