function[xmin] = guess_linesearch_uy(model, errors, searchDir, data_ls)
% function[xmin,  cost_new, errors_new] = guess_linesearch_uy(model, errors, searchDir, data_ls)

 n = data_ls.nentries;
 searchDir.U = searchDir.U; 
 searchDir.Y = searchDir.Y;

% preds_ls = proj_omega_sub(model.G, model.H, data_ls.rows, data_ls.cols);
% errors = (preds_ls - data_ls.entries);

% s_star_u = proj_omega_sub(model.U  , searchDir.Y, data_ls.rows, data_ls.cols);
% s_star_z = proj_omega_sub(searchDir.U,   model.Y, data_ls.rows, data_ls.cols);
% s_star = s_star_u + s_star_z;


% s_star = proj_omega_sub([model.U    searchDir.U], [searchDir.Y  model.Y ], data_ls.rows, data_ls.cols);
s_star = partXY([model.U    searchDir.U]', [searchDir.Y  model.Y ]', data_ls.rows, data_ls.cols, n)';


% s_star_uy = proj_omega_sub(searchDir.U, searchDir.Y, data_ls.rows, data_ls.cols);
s_star_uy = partXY(searchDir.U', searchDir.Y', data_ls.rows, data_ls.cols, n)';



% A degree 4 polynomial
p = (s_star_uy'*s_star_uy);%sum(s_star_uy.^2);
q = 2*(s_star_uy'*s_star);% 2*sum(s_star_uy .* s_star);
r = 2*(s_star_uy'*errors) + (s_star'*s_star); % 2*sum(s_star_uy .* errors) + sum(s_star.^2);
s = 2*(errors'*s_star);% 2*sum(errors .* s_star);
t = (errors'*errors);% sum(errors .^ 2);
%  old_cost = t / n% old cost


% Solving the derivative of the degree 4 polynomial to find the global
% minimum

coefficients = [4*p , 3*q, 2*r, s];
xs = roots(coefficients);
real_roots = [];

for ii = 1 : 3
    if isreal(xs(ii))% && xs(ii) > 0
        real_roots = [real_roots; xs(ii)];
    end
end 

real_roots = 0.5*(real_roots + abs(real_roots));

fun_val = [];
for jj = 1 : length(real_roots)
      x = real_roots(jj);
      fun_val = [fun_val ; p*(x^4) + q*(x^3) + r*(x^2) + s*x + t ];
end

[fmin, idx] = min(fun_val);

xmin = real_roots(idx);  % Global minimum

% if isempty(xmin)
%     xmin = 0;
%     fmin = t
% end

cost_new = fmin /n;

errors_new = errors + xmin*s_star + (xmin^2)*s_star_uy;

