function [Hess] = hess_uy(prob, x, h)

%   s_star_single_proj = proj_omega_sub([h.U x.U], [x.Y h.Y], prob.Omega_i, prob.Omega_j);
  s_star_single_proj = partXY([h.U x.U]', [x.Y h.Y]', prob.Omega_i, prob.Omega_j, prob.m)';

  
  updateSparse(prob.temp_omega, s_star_single_proj);
  %prob.temp_omega = prob.temp_omega;
  S_star = prob.temp_omega;
      
  
  Hess.U = S_star*x.Y;
  Hess.Y = S_star'*x.U*(x.YtY);
  
%   d = (x.on_omega - prob.data);
%   updateSparse(prob.temp_omega, d);
%   prob.temp_omega = prob.temp_omega;
%   S = prob.temp_omega;  
  
  if isempty(x.cache.S)
      d = (x.on_omega - prob.data);
      updateSparse(prob.temp_omega, d);
      prob.temp_omega = prob.temp_omega;
      S = prob.temp_omega;
  else
      S = x.cache.S;
  end
  
  
  if isempty(x.cache.SY)
      SY = S*x.Y;
      SU = S'*x.U;
  else
      SY = x.cache.SY;
      SU = x.cache.SU;
  end
  
  ShY = S*h.Y;
  ShU = S'*h.U;
  
  Hess.U = Hess.U + ShY;
%   Hess.U = proj_tangent_space_stiefel(Hess.U,x.U) - proj_tangent_space_stiefel(h.U*symm(x.U'*(SY)),x.U); % original
  Hess.U = proj_tangent_space_stiefel(Hess.U - h.U*symm(x.U'*(SY)),x.U); % original

  
  
  Hess.Y = Hess.Y + 2*SU*symm(h.Y'*x.Y) + ShU*(x.YtY);
  
  if isempty(x.cache.gradY)
      grad.Y = SU*(x.YtY);
  else
      grad.Y = x.cache.gradY;
  end
  if isempty(x.cache.YgradY)
      YgradY = x.Y'*grad.Y;
  else
      YgradY = x.cache.YgradY;
  end
  
  
  Hess.Y = Hess.Y - grad.Y*((x.YtY)\symm(x.Y'*h.Y)) - h.Y*((x.YtY)\symm(YgradY)) + x.Y*((x.YtY)\symm(h.Y'*grad.Y));
  
  Hess = removeVxM_uy(x, Hess);
  

end