function params = default_params(params)
% params = default_params(params)
% Set default parameters


  % Tolerance on absolute value
  if ~isfield(params,'tol'),
    params.tol = 1e-5;
  end
  
  % Tolerance on relative value
  if ~isfield(params,'vtol'),
    params.vtol = 1e-5;
  end
  
  % Verbosity
  if ~isfield(params,'verb'),
    params.verb = true;
  end
  
  % Maximum step size during line-search
  if ~isfield(params,'max_step')
    params.max_step = 100;
  end

  % Parameter of the Armijo step
  if ~isfield(params,'sigma_armijo'),
    params.sigma_armijo = 0.5;
  end
  
  % Maximum number of line-search steps
  if ~isfield(params,'ls_maxiter'),
    params.ls_maxiter = 100;
  end
  
  % Maximum number of iterations
  if ~isfield(params,'maxiter'),
    params.maxiter = 10000;
  end
  
  % Exact linesearch or adapative
  if ~isfield(params,'exact_linesearch'),
    params.exact_linesearch = true;
  end
  
  % beta_type = 
  %    'off' = steepest descent, 
  %    'F-R' = Fletcher-Reeves, 
  %    'P-R' = Polak-Ribbiere
  if ~isfield(params,'beta_type'),
    params.beta_type = 'P-R';
  end

  % Compute test error
  if ~isfield(params,'compute_predictions'),
      params.compute_predictions = false;
  end
  
  % Measure orthogonality while computing conjugate direction
  if ~isfield(params,'orth_value'),
      params.orth_value = 0.1;
  end
end