function[Z_G Z_H] = proj_horizontal_space_gh(eta, model)
% [Z_G Z_H] = proj_horizontal_space_gh(eta, model)
%
% Projecting a vector "eta" onto the horizontal space at the iterate "model".
% The output: Z_G: Projected left factor
%           : Z_H: Projected right factor
% 
% Author:
% Bamdev Mishra, <b.mishra@ulg.ac.be>, 2012

Lambda = (eta.H'*model.HinvHtH) -  (model.GinvGtG'*eta.G);
% Lambda = (eta.H'*model.H)/model.HtH  -  model.GtG\(model.G'*eta.G);
Lambda = Lambda/2;

Z_G = eta.G + (model.G*Lambda); % on the horizontal space
Z_H = eta.H - (model.H*Lambda'); % on the horizontal space

return

