function eta_new = vector_transport_gh(model, eta, model_new)
% [eta_new] = vector_transport_gh(model, eta, model_new)
%
% Transport the vector "eta" at "model" to the new iterate, "model_new"
% The output is the trasported vector "eta_new" at the iterate "model_new".
%
% Author:
% Bamdev Mishra, <b.mishra@ulg.ac.be>, 2012

ip_old = inner_product_gh(model, eta, eta);

[Z_G Z_H] = proj_horizontal_space_gh(eta, model_new);
eta_new.G = Z_G;
eta_new.H = Z_H;

ip_new = inner_product_gh(model_new, eta_new, eta_new);

scaling = (ip_old / ip_new);

eta_new.G = scaling * eta_new.G;
eta_new.H = scaling * eta_new.H;

return

