function [X,out] = geom_rtr_common_gh(M,par)
%common interface for geometric RTR
clear X;

% Default options
options.abs_f_tol = 0;
options.abs_grad_tol = 0;
%options.rel_f_tol = 1e-4;
options.maxit = 100;
options.nb_k = 1;
options.verbosity = 1;
options.compute_predictions = 0;


options.tol_cost = par.opts.tol_cost;
options.verbosity = par.opts.verbosity;
options.compute_predictions = par.opts.compute_predictions;
options.guess_Delta = par.opts.guess_Delta;

if nargin == 2
    if isfield(par,'rank'); options.rank = par.rank; 
    elseif isfield(par,'est_type'); options.rank = rank_est(M,par.est_type); 
    else options.rank = rank_est(M,options.est_type); 
    end
    if isfield(par,'maxiter'); options.maxit = par.maxiter; end
    if isfield(par,'max_inner'); options.max_inner = par.max_inner; end
    if isfield(par,'tol'); options.rel_f_tol = par.tol; end
    if isfield(par,'abs_grad_tol'); options.abs_grad_tol = par.abs_grad_tol; end
end


prob = par.prob;



[X,stats] = rtr_rank_gh(prob, options, par.x);


out.numiter = length([stats.k]);
