function[grad x] = grad_gh(prob, x)
% Computes gradient and stores some variables 

  d = (x.on_omega - prob.data);
  updateSparse(prob.temp_omega_2, d);
  prob.temp_omega_2 = prob.temp_omega_2;
  S = prob.temp_omega_2;
  
  SH = S*x.H;
  SG = S'*x.G; 
  
  grad.G = SH*(x.invHtH);

  grad.H = SG*(x.invGtG);
  
  x.cache.d = d;
  x.cache.S = S;
  x.cache.SH = SH;
  x.cache.SG = SG;
  x.gradG = grad.G;
  x.gradH = grad.H;
  x.GgradG = x.G'*grad.G;
  x.HgradH = x.H'*grad.H;
 
end